WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
    mov     wc.cbSize, SIZEOF WNDCLASSEX
    mov     wc.style, NULL
    mov     wc.lpfnWndProc, OFFSET WndProc
    mov     wc.cbClsExtra, NULL
    mov     wc.cbWndExtra, NULL
    m2m     wc.hInstance, hInstance
    mov     wc.hbrBackground, COLOR_WINDOW
    mov     wc.lpszMenuName, IDM_MAINMENU
    mov     wc.lpszClassName, OFFSET ClassName
    invoke  LoadIcon, hInst, IDI_DC
    mov     wc.hIcon, eax
    mov     wc.hIconSm, eax
    invoke  LoadCursor, NULL, IDC_SIZEWE
    mov     wc.hCursor, eax
    invoke  xCenterWnd
    invoke  RegisterClassEx, addr wc
    invoke  CreateWindowEx, WS_EX_CLIENTEDGE, ADDR ClassName, ADDR AppName,\
            WS_OVERLAPPED + WS_CAPTION + WS_SYSMENU + WS_MINIMIZEBOX + WS_MAXIMIZEBOX + WS_SIZEBOX + WS_VISIBLE,\
            dwCX, dwCY, dwW, dwH, NULL, NULL, hInst, NULL
    mov     hwnd, eax
    .while  TRUE
       invoke   GetMessage, ADDR msg, NULL, 0, 0
        .break  .if (!eax)
        invoke  TranslateMessage, ADDR msg
        invoke  DispatchMessage, ADDR msg
    .endw
    mov     eax, msg.wParam
    ret
WinMain endp

xCenterWnd proc
    invoke  GetSystemMetrics, SM_CXSCREEN
    mov     dwCX, eax
    shr     dwCX, 2
    sub     eax, dwCX
    mov     dwW, eax
    shr     dwCX, 1
    invoke  GetSystemMetrics, SM_CYSCREEN
    mov     dwCY, eax
    shr     dwCY, 2
    sub     eax, dwCY
    mov     dwH, eax
    shr     dwCY, 1
    ret
xCenterWnd endp

xGetDrives proc uses edi esi
local dwDrives:DWORD
local dwNDrives:DWORD
    mov     tvinsert.item.imask, TVIF_TEXT + TVIF_IMAGE + TVIF_SELECTEDIMAGE
    mov     tvinsert.item.pszText, offset szMC
    mov     tvinsert.item.iImage, 3
    mov     tvinsert.item.iSelectedImage, 3
    mov     tvinsert.hInsertAfter, TVI_ROOT
    invoke  SendMessage, hTV, TVM_INSERTITEM, 0, addr tvinsert
    mov     hMC, eax
    mov dwNDrives, 0
    lea esi, buf
    lea edi, bFixed
    invoke  GetLogicalDrives
    mov     dwDrives, eax
    invoke  GetLogicalDriveStrings, 0400h, esi
@1: shr     dwDrives, 1
    jnc     @F
    invoke  GetDriveType, esi
    and     eax, 1                      ;   FIXED or CDROM ?
    .if eax
        mov ecx, 4
        rep movsb                       ;   adds ecx to esi and edi
        inc dwNDrives
    .else
        add esi, 4                      ;   adjust for read next
    .endif
    m2m     nDrives, dwNDrives
@@: cmp     dwDrives, 0
    jne     @1
        xor     esi, esi                ;   put drives in TreeView
        lea     edi, bFixed
@@:     m2m     tvinsert.hParent, hMC   ;   root
        mov     tvinsert.hInsertAfter, TVI_LAST
        mov     tvinsert.item.pszText, offset bFixed
        add     tvinsert.item.pszText, esi
        invoke  GetDriveType, edi
        .if eax == DRIVE_FIXED          ;   FIXED
            mov     tvinsert.item.iImage, 2
            mov     tvinsert.item.iSelectedImage, 2
        .else                           ;   CDROM
            mov     tvinsert.item.iImage, 6
            mov     tvinsert.item.iSelectedImage, 6
        .endif
        invoke  SendMessage, hTV, TVM_INSERTITEM, 0, addr tvinsert
        mov     hDrives[esi], eax
        add     esi, 4
        add     edi, 4
        dec     dwNDrives
        jne     @B
    Ret
xGetDrives endp

xGetDir proc hItm:HANDLE
    mov     BufTo, 0
@@: mov     bFrom, 0
    mov     tvinsert.item.pszText, offset bTo
    mov     tvinsert.item.cchTextMax, 400h
    m2m     tvinsert.item.hItem, hItm
    invoke  SendMessage, hTV, TVM_GETITEM, 0, addr tvinsert.item
    invoke  lstrcat, addr bFrom, tvinsert.item.pszText
    invoke  PathAddBackslash, addr bFrom
    invoke  lstrcat, addr bFrom, addr BufTo
    mov     BufTo, 0
    invoke  lstrcat, addr BufTo, addr bFrom
    invoke  SendMessage, hTV, TVM_GETNEXTITEM, TVGN_PARENT, hItm
    mov     hItm, eax
    .if eax != hMC
        jmp     @B
    .endif
    invoke  SetCurrentDirectory, addr BufTo
    mov     tvinsert.item.iImage, 0
    mov     tvinsert.item.iSelectedImage, 1
    ret
xGetDir endp

xXpandFolder proc   hCP:HANDLE
local hFnd:DWORD
    mov     eax, hCP
    .if eax == hMC
        jmp     @F
    .endif
    invoke  SetCurrentDirectory, addr BufTo
    .if !eax
        ret
    .endif
@@: mov     tvitem.imask, TVIF_PARAM
    m2m     tvitem.hItem, hCP
    invoke  SendMessage, hTV, TVM_GETITEM, 0, addr tvitem
    .if tvitem.lParam != 1
        mov     tvitem.lParam, 1
        invoke  SendMessage, hTV, TVM_SETITEM, 0, addr tvitem
        m2m     tvinsert.hParent, hCP
        mov     tvinsert.hInsertAfter, TVI_SORT
        invoke  FindFirstFile, addr szSDS, addr finddata
        .if eax == INVALID_HANDLE_VALUE
            xor     eax, eax
            ret
        .endif
        mov     hFnd, eax
        .while eax!=0
            test    finddata.dwFileAttributes, FILE_ATTRIBUTE_DIRECTORY
            .if !ZERO? 
                lea     eax, finddata.cFileName
                mov     tvinsert.item.pszText, eax
                mov     al, [eax]
                .if al != "."   ;   valid folder name
                    invoke  SendMessage, hTV, TVM_INSERTITEM, 0, addr tvinsert
                .endif
            .endif
            invoke  FindNextFile, hFnd, addr finddata
        .endw
        invoke  FindClose, hFnd
        invoke  SendMessage, hTV, TVM_EXPAND, TVE_EXPAND, hCP
    .endif
    ret
xXpandFolder endp

xInitLogFont proc
    invoke  RtlZeroMemory, addr cf, sizeof cf
    invoke  RtlZeroMemory, addr lff, sizeof lff
    invoke  RtlZeroMemory, addr lfi, sizeof lfi
    mov     cf.lStructSize, sizeof cf
    mov     cf.Flags, CF_EFFECTS or CF_SCREENFONTS or CF_INITTOLOGFONTSTRUCT
    m2m     cf.hwndOwner, hwnd
    mov     cf.iPointSize, 12
    invoke  lstrcat, addr lff.lfFaceName, addr szFont
    invoke  lstrcat, addr lfi.lfFaceName, addr szFont
    mov     lff.lfWeight, 2bch
    mov     lfi.lfWeight, 190h
    mov     lff.lfHeight, 0fffffff4h
    mov     lfi.lfHeight, 0fffffff4h
    mov     lff.lfOutPrecision, 1
    mov     lfi.lfOutPrecision, 1
    mov     lff.lfClipPrecision, 2
    mov     lfi.lfClipPrecision, 2
    mov     lff.lfQuality, 1
    mov     lfi.lfQuality, 1
    mov     lff.lfPitchAndFamily, 22h
    mov     lfi.lfPitchAndFamily, 22h
    mov     lff.lfFaceName, 4dh
    mov     lfi.lfFaceName, 4dh
    ret
xInitLogFont endp

xCreateFont proc  uses edi esi phFont:ptr HANDLE, pLF:ptr LOGFONT, pColor:ptr COLORREF, pChrFmt:ptr CHARFORMAT
    mov     edi, pColor
    m2m     cf.rgbColors, [edi]
    m2m     cf.lpLogFont, pLF
    mov     eax, 1
    .if fFnt
        invoke  ChooseFont, addr cf
    .endif
    .if eax
        m2m     [edi], cf.rgbColors
        assume  edi:ptr LOGFONT
        assume  esi:ptr CHARFORMAT
        mov     edi, pLF
        mov     esi, pChrFmt
        mov     eax, phFont
        .if eax
            invoke  DeleteObject, [eax]
        .endif
        mov     [esi].dwMask, CFM_BOLD or CFM_CHARSET or CFM_COLOR or CFM_FACE or CFM_ITALIC or CFM_OFFSET or CFM_SIZE or CFM_STRIKEOUT or CFM_UNDERLINE
        xor     eax, eax
        .if [edi].lfItalic
            mov     eax, CFE_ITALIC
        .endif
        .if [edi].lfStrikeOut
            or      eax, CFE_STRIKEOUT
        .endif
        .if [edi].lfUnderline
            or      eax, CFE_UNDERLINE
        .endif
        .if [edi].lfWeight == 2bch
            or      eax, CFE_BOLD
        .endif
        mov     [esi].dwEffects, eax
        mov     al, [edi].lfCharSet
        mov     [esi].bCharSet, al
        mov     al, [edi].lfPitchAndFamily
        mov     [esi].bPitchAndFamily, al
        mov     eax, pColor
        mov     eax, [eax]
        mov     [esi].crTextColor, eax
        mov     [esi].szFaceName, 0
        invoke  lstrcat, addr [esi].szFaceName, addr [edi].lfFaceName
        m2m     [esi].yHeight, [edi].lfHeight
        iabs    [esi].yHeight
        shl     [esi].yHeight, 4
        

        invoke  CreateFont, [edi].lfHeight, [edi].lfWidth, [edi].lfEscapement, [edi].lfOrientation, [edi].lfWeight, \
                            [edi].lfItalic, [edi].lfUnderline, [edi].lfStrikeOut, [edi].lfCharSet, [edi].lfOutPrecision, \
                            [edi].lfClipPrecision, [edi].lfQuality, [edi].lfPitchAndFamily, [edi].lfFaceName
        assume  edi:nothing
        assume  esi:nothing
;=========================================HERE
        mov     edi, phFont
        mov     [edi], eax
;     I'm trying to replace above two lines with following:
;        mov     DWORD ptr [phFont], eax      ;   seems like this should work but it doesn't
;=========================================HERE
    .endif
    ret
xCreateFont endp

xWrite proc
local bName[256]:BYTE
local tvi:TVITEM
    mov     bName, 0
    invoke  SendMessage, hEdit, EM_SETSEL, 0, -1
    invoke  SendMessage, hEdit, EM_REPLACESEL, TRUE, addr bName
    mov     tvi.imask, TVIF_TEXT or TVIF_HANDLE or TVIF_IMAGE
    m2m     tvi.hItem, hMC
    mov     tvi.cchTextMax, sizeof bName
    lea     eax, bName
    mov     tvi.pszText, eax 
@1: invoke  SendMessage, hTV, TVM_GETNEXTITEM, TVGN_CHILD, tvi.hItem
@2: .if eax
        mov     tvi.hItem, eax
        invoke  SendMessage, hTV, TVM_GETITEM, 0, addr tvi
        .if tvi.iImage == 4
            invoke  xDoWriting, addr tvi
        .elseif tvi.iImage == 7
            invoke  xDoWriting, addr tvi
        .elseif tvi.iImage == 8
            invoke  xDoWriting, addr tvi
        .endif
        jmp     @1
    .endif
@3: invoke  SendMessage, hTV, TVM_GETNEXTITEM, TVGN_NEXT, tvi.hItem
    .if eax
        jmp     @2
    .endif
    invoke  SendMessage, hTV, TVM_GETNEXTITEM, TVGN_PARENT, tvi.hItem
    mov     tvi.hItem, eax
    mov     eax, hMC
    .if eax != tvi.hItem
        jmp     @3
    .endif
    ret
xWrite endp

xDoWriting proc  uses edi esi  pTV:ptr TVITEM
local bPos[10]:DWORD
local hFind:HANDLE
    mov     edi, pTV
    invoke  xGetDir, [edi].TVITEM.hItem
                                                                                    ;   FOLDERS
    .if !dwCBF
        jmp     @2
    .endif
    .if dwCBO
        jmp     @1
    .else
        invoke  FindFirstFile, addr bExt, addr finddata
        .if eax != INVALID_HANDLE_VALUE
            mov     hFind, eax
            .while eax
                test    finddata.dwFileAttributes, FILE_ATTRIBUTE_DIRECTORY
                .if ZERO?
                    invoke  FindClose, hFind
                    jmp     @1
                .endif
                invoke  FindNextFile, hFind, addr finddata
            .endw
            invoke  FindClose, hFind
        .endif
        ret
    .endif
    invoke  FindFirstFile, addr bExt, addr finddata
    .if eax != INVALID_HANDLE_VALUE
        mov     hFind, eax
@1:     invoke  SendMessage, hEdit, EM_SETCHARFORMAT, SCF_SELECTION, addr cff
        invoke  SendMessage, hEdit, EM_REPLACESEL, FALSE, addr szcr
        invoke  SendMessage, hEdit, EM_REPLACESEL, FALSE, addr szTab
        .if dwCBP
                .if cbUCF
                    invoke  CharUpper, addr bFrom
                .elseif cbLCF
                    invoke  CharLower, addr bFrom
                .endif
            invoke  SendMessage, hEdit, EM_REPLACESEL, FALSE, addr bFrom
        .else
                .if cbUCF
                    invoke  CharUpper, [edi].TVITEM.pszText
                .elseif cbLCF
                    invoke  CharLower, [edi].TVITEM.pszText
                .endif
            invoke  SendMessage, hEdit, EM_REPLACESEL, FALSE, [edi].TVITEM.pszText
        .endif
        invoke  FindClose, hFind
    .endif
                                                                                    ;   ITEMS
@2: .if dwCBI
        invoke  FindFirstFile, addr bExt, addr finddata
        .if eax != INVALID_HANDLE_VALUE
            mov     hFind, eax
            invoke  SendMessage, hEdit, EM_SETCHARFORMAT, SCF_SELECTION, addr cfi
@3:         test    finddata.dwFileAttributes, FILE_ATTRIBUTE_DIRECTORY
            .if ZERO?
                 invoke  SendMessage, hEdit, EM_REPLACESEL, FALSE, addr szcr
                .if !dwCBE
                    invoke  PathRemoveExtension, addr finddata.cFileName
                .endif
                .if cbUCI
                    invoke  CharUpper, addr finddata.cFileName
                .elseif cbLCI
                    invoke  CharLower, addr finddata.cFileName
                .endif
                invoke  SendMessage, hEdit, EM_REPLACESEL, FALSE, addr finddata.cFileName
            .endif
            invoke  FindNextFile, hFind, addr finddata
            .if eax
                jmp     @3
            .endif
        .endif
        invoke  FindClose, hFind
    .endif
    ret
xDoWriting endp

xPrefDlgProc proc   uses edi    hDlg:HANDLE, iMsg:DWORD, wParam:WPARAM, lParam:LPARAM
    .if iMsg == WM_INITDIALOG
        invoke  RegisterHotKey, hDlg, DLG_ESCAPE, NULL, VK_ESCAPE
        invoke  RegisterHotKey, hDlg, DLG_RETURN, NULL, VK_RETURN
        invoke  GetDlgItem, hDlg, IDC_COMBO
        mov     hCombo, eax
        invoke  GetDlgItem, hDlg, IDC_CB_FOLDER
        mov     hCBF, eax
        invoke  GetDlgItem, hDlg, IDC_CB_ITEM
        mov     hCBI, eax
        invoke  GetDlgItem, hDlg, IDC_CB_EXT
        mov     hCBE, eax
        invoke  GetDlgItem, hDlg, IDC_CB_INC
        mov     hCBO, eax
        invoke  GetDlgItem, hDlg, IDC_CB_PATH
        mov     hCBP, eax
        invoke  GetDlgItem, hDlg, IDC_CB_LCI
        mov     hCBLCI, eax
        invoke  GetDlgItem, hDlg, IDC_CB_LCF
        mov     hCBLCF, eax
        invoke  GetDlgItem, hDlg, IDC_CB_UCI
        mov     hCBUCI, eax
        invoke  GetDlgItem, hDlg, IDC_CB_UCF
        mov     hCBUCF, eax
        invoke  SendMessage, hCBI, BM_SETCHECK, dwCBI, 0
        invoke  SendMessage, hCBF, BM_SETCHECK, dwCBF, 0
        invoke  SendMessage, hCBE, BM_SETCHECK, dwCBE, 0
        invoke  SendMessage, hCBO, BM_SETCHECK, dwCBO, 0
        invoke  SendMessage, hCBP, BM_SETCHECK, dwCBP, 0
        invoke  SendMessage, hCBLCI, BM_SETCHECK, cbLCI, 0
        invoke  SendMessage, hCBLCF, BM_SETCHECK, cbLCF, 0
        invoke  SendMessage, hCBUCI, BM_SETCHECK, cbUCI, 0
        invoke  SendMessage, hCBUCF, BM_SETCHECK, cbUCF, 0
        invoke  xRegInit
        invoke  SendMessage, hCombo, CB_SETCURSEL, cbSel, 0
        invoke  SendMessage, hCombo, CB_GETLBTEXT, cbSel, addr bExt
    .elseif iMsg == WM_CLOSE
        invoke  UnregisterHotKey, hDlg, DLG_ESCAPE
        invoke  UnregisterHotKey, hDlg, DLG_RETURN
        invoke	EndDialog, hDlg, NULL
    .elseif iMsg == WM_HOTKEY
        .if wParam == DLG_ESCAPE
            invoke  SendMessage, hDlg, WM_CLOSE, 0, 0
        .elseif wParam == DLG_RETURN
            mov     ax, BN_CLICKED
            shl     eax, 16
            mov     ax, IDC_OK
            invoke  SendMessage, hDlg, WM_COMMAND, eax, NULL
        .endif
    .elseif	iMsg == WM_COMMAND
        mov     edi, lParam
        mov     eax, wParam
        mov     edx, eax
        shr     edx, 16
        .if dx == BN_CLICKED
            .if ax == IDC_OK
                .if fEditChanged
                    szText  szAdd, "Add String To List?"
                    invoke  SendMessage, hCombo, CB_SETEDITSEL, 0, 0ffff0000h
                    invoke  SendMessage, hCombo, WM_GETTEXT, sizeof bFrom, ADDR bFrom
                    mov     bExt2, 0
                    mov     bTo, 0
                    lea     eax, bFrom
                    mov     pBuf, eax
                    mov     al, [eax]
                    .if al == "*"
                        add     pBuf, 2
                    .endif
                    invoke  lstrcat, addr bExt2, pBuf
                    invoke  lstrcat, addr bTo, addr szSD
                    invoke  lstrcat, addr bTo, pBuf
                    invoke  MessageBox, NULL, addr bTo, addr szAdd, MB_YESNO
                    .if eax == IDYES
                        invoke  xRegAdd
                        mov     bExt, 0
                        invoke  lstrcat, addr bExt, addr bTo
                    .endif
                    mov     fEditChanged, 0
                    invoke  SendMessage, hCombo, CB_ADDSTRING, 0, addr bTo
                    mov     cbSel, eax
                    invoke  SendMessage, hCombo, CB_SETCURSEL, eax, 0
                .endif
                invoke  SendMessage, hCBI, BM_GETCHECK, 0, 0
                mov     dwCBI, eax
                invoke  SendMessage, hCBF, BM_GETCHECK, 0, 0
                mov     dwCBF, eax
                invoke  SendMessage, hCBE, BM_GETCHECK, 0, 0
                mov     dwCBE, eax
                invoke  SendMessage, hCBO, BM_GETCHECK, 0, 0
                mov     dwCBO, eax
                invoke  SendMessage, hCBP, BM_GETCHECK, 0, 0
                mov     dwCBP, eax
                invoke  UnregisterHotKey, hDlg, DLG_ESCAPE
                invoke  UnregisterHotKey, hDlg, DLG_RETURN
                invoke  EndDialog, hDlg, TRUE
                invoke  xWrite
            .elseif ax == IDC_CB_LCI
                invoke  SendMessage, hCBLCI, BM_GETCHECK, 0, 0
                mov     cbLCI, eax
                .if eax
                    invoke  SendMessage, hCBUCI, BM_SETCHECK, BST_UNCHECKED, 0
                    mov     cbUCI, 0
                .endif
            .elseif ax == IDC_CB_UCI
                invoke  SendMessage, hCBUCI, BM_GETCHECK, 0, 0
                mov     cbUCI, eax
                .if eax
                    invoke  SendMessage, hCBLCI, BM_SETCHECK, BST_UNCHECKED, 0
                    mov     cbLCI, 0
                .endif
            .elseif ax == IDC_CB_LCF
                invoke  SendMessage, hCBLCF, BM_GETCHECK, 0, 0
                mov     cbLCF, eax
                .if eax
                    invoke  SendMessage, hCBUCF, BM_SETCHECK, BST_UNCHECKED, 0
                    mov     cbUCF, 0
                .endif
            .elseif ax == IDC_CB_UCF
                invoke  SendMessage, hCBUCF, BM_GETCHECK, 0, 0
                mov     cbUCF, eax
                .if eax
                    invoke  SendMessage, hCBLCF, BM_SETCHECK, BST_UNCHECKED, 0
                    mov     cbLCF, 0
                .endif
            .elseif ax == IDC_CANCEL
                mov     fEditChanged, 0
                invoke  UnregisterHotKey, hDlg, DLG_ESCAPE
                invoke  UnregisterHotKey, hDlg, DLG_RETURN
                invoke  EndDialog, hDlg, FALSE
            .elseif ax == IDC_REMOVE
                szText  szRemov, "Remove String From List?"
                invoke  SendMessage, hCombo, CB_SETEDITSEL, 0, 0ffff0000h
                invoke  SendMessage, hCombo, WM_GETTEXT, sizeof bFrom, ADDR bFrom
                invoke  MessageBox, NULL, addr bFrom, addr szRemov, MB_YESNO
                .if eax == IDYES
                    invoke  SendMessage, hCombo, CB_GETCURSEL, 0, 0
                    invoke  SendMessage, hCombo, CB_DELETESTRING, eax, 0
                    invoke  xRegRemove
                .endif
            .endif
        .elseif dx == CBN_SELCHANGE
            invoke  SendMessage, lParam, CB_GETCURSEL, 0, 0
            mov     cbSel, eax
            invoke  SendMessage, lParam, CB_GETLBTEXT, eax, addr bExt
            mov     fEditChanged, 0
        .elseif dx == CBN_EDITCHANGE
            mov     fEditChanged, 1
        .endif
    .endif
    Ret
xPrefDlgProc EndP

xAboutDlgProc proc    hDlg:HANDLE, iMsg:DWORD, wParam:WPARAM, lParam:LPARAM

    ret
xAboutDlgProc endp

xRegInit proc
local hKey:HANDLE
local hSKey:HANDLE
local bSDE[50]:BYTE
local dwIndex:DWORD
    mov     dwIndex, 0
    invoke  RegOpenKeyEx, HKEY_CURRENT_USER, addr szKey, 0, NULL, addr hKey
    .if eax
        invoke  RegCreateKey, HKEY_CURRENT_USER, addr szKey, addr hKey
        invoke  RegCreateKey, hKey, addr szMP3, addr hSKey
        invoke  RegCloseKey, addr hSKey
        invoke  RegCreateKey, hKey, addr szTXT, addr hSKey
        invoke  RegCloseKey, addr hSKey
        invoke  RegCreateKey, hKey, addr szJPG, addr hSKey
        invoke  RegCloseKey, addr hSKey
        invoke  RegCreateKey, hKey, addr szBMP, addr hSKey
        invoke  RegCloseKey, addr hSKey
    .endif
    invoke  RegEnumKey, hKey, dwIndex, addr bExt, 50
    .while !eax
        mov     bSDE, 0
        invoke  lstrcat, addr bSDE, addr szSD
        invoke  lstrcat, addr bSDE, addr bExt
        inc     dwIndex
        invoke  SendMessage, hCombo, CB_ADDSTRING, 0, addr bSDE
        invoke  RegEnumKey, hKey, dwIndex, addr bExt, 50
    .endw
    invoke  RegCloseKey, addr hKey
    ret
xRegInit endp

xRegAdd proc
local hKey:HANDLE
local hSKey:HANDLE
    invoke  RegOpenKeyEx, HKEY_CURRENT_USER, addr szKey, 0, NULL, addr hKey
    invoke  RegCreateKey, hKey, addr bExt2, addr hSKey
    invoke  RegCloseKey, addr hSKey
    ret
xRegAdd endp

xRegRemove proc
local hKey:HANDLE
local hSKey:HANDLE
    invoke  RegOpenKeyEx, HKEY_CURRENT_USER, addr szKey, 0, NULL, addr hKey
    lea     eax, bFrom
    add     eax, 2
    invoke  RegDeleteKey, hKey, eax
    invoke  RegCloseKey, addr hSKey
    ret
xRegRemove endp

xMarkAll proc   fMark:DWORD     ;   fMark, 0 = unmark, 1 = mark <> bFrom = curent directory <> hTVCP = curent select
    m2m     tvitem.hItem, hTVCP
    invoke  SendMessage, hTV, TVM_GETNEXTITEM, TVGN_CHILD, tvitem.hItem
    .if !eax
        ret
    .endif
    .if fMark
        mov     tvitem.iSelectedImage, 5
        mov     tvitem.iImage, 4 
    .else
        mov     tvitem.iSelectedImage, 1
        mov     tvitem.iImage, 0 
    .endif
@1: invoke  SendMessage, hTV, TVM_GETNEXTITEM, TVGN_CHILD, tvitem.hItem
@2: .if eax
        mov     tvitem.hItem, eax
        invoke  xGetDir, tvitem.hItem
        invoke  xXpandFolder, tvitem.hItem
        mov     tvitem.imask, TVIF_IMAGE or TVIF_SELECTEDIMAGE
        invoke  SendMessage, hTV, TVM_EXPAND, TVE_EXPAND, tvitem.hItem
        jmp     @1
    .endif
@3: invoke  SendMessage, hTV, TVM_SETITEM, 0, addr tvitem
    invoke  SendMessage, hTV, TVM_GETNEXTITEM, TVGN_NEXT, tvitem.hItem
    .if eax
        jmp     @2
    .endif
    invoke  SendMessage, hTV, TVM_GETNEXTITEM, TVGN_PARENT, tvitem.hItem
    mov     tvitem.hItem, eax
    mov     eax, hTVCP
    .if eax != tvitem.hItem
        jmp     @3
    .endif
    ret
xMarkAll endp

xList proc
    mov     tvitem.imask, TVIF_IMAGE or TVIF_SELECTEDIMAGE
    m2m     tvitem.hItem, hTVCP
    invoke  SendMessage, hTV, TVM_GETITEM, 0, addr tvitem
    .if tvitem.iImage == 0
        mov     tvitem.iSelectedImage, 5
        mov     tvitem.iImage, 4 
        invoke  SendMessage, hTV, TVM_SETITEM, 0, addr tvitem
        invoke  xWrite
    .elseif tvitem.iImage == 2
        mov     tvitem.iSelectedImage, 7
        mov     tvitem.iImage, 7 
        invoke  SendMessage, hTV, TVM_SETITEM, 0, addr tvitem
        invoke  xWrite
    .elseif tvitem.iImage == 6
        mov     tvitem.iSelectedImage, 8
        mov     tvitem.iImage, 8 
        invoke  SendMessage, hTV, TVM_SETITEM, 0, addr tvitem
        invoke  xWrite
    .endif
    ret
xList endp

xUnList proc
    mov     tvitem.imask, TVIF_IMAGE or TVIF_SELECTEDIMAGE
    m2m     tvitem.hItem, hTVCP
    invoke  SendMessage, hTV, TVM_GETITEM, 0, addr tvitem
    .if tvitem.iImage == 4
        mov     tvitem.iSelectedImage, 1
        mov     tvitem.iImage, 0 
        invoke  SendMessage, hTV, TVM_SETITEM, 0, addr tvitem
        invoke  xWrite
    .elseif tvitem.iImage == 7
        mov     tvitem.iSelectedImage, 2
        mov     tvitem.iImage, 2 
        invoke  SendMessage, hTV, TVM_SETITEM, 0, addr tvitem
        invoke  xWrite
    .elseif tvitem.iImage == 8
        mov     tvitem.iSelectedImage, 6
        mov     tvitem.iImage, 6 
        invoke  SendMessage, hTV, TVM_SETITEM, 0, addr tvitem
        invoke  xWrite
    .endif
    ret
xUnList endp

xSaveas proc
local ofn:OPENFILENAME
        invoke  RtlZeroMemory, addr ofn, sizeof ofn
        mov     ofn.lStructSize, sizeof ofn
        m2m     ofn.hwndOwner, hwnd
        m2m     ofn.hInstance, hInstance
        mov     ofn.lpstrFilter, offset szFilter
        mov     ofn.nFilterIndex, 1
        mov     ofn.lpstrFile, offset AltFileName
        mov     AltFileName, 0
        mov     ofn.lpstrDefExt, offset szDefExt
        mov     ofn.lpstrInitialDir, offset szInitDir
        mov     ofn.nMaxFile, sizeof AltFileName
        mov     ofn.Flags, OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or OFN_PATHMUSTEXIST
        invoke  GetSaveFileName, addr ofn
        .if eax != 0
            invoke  CreateFile, ofn.lpstrFile, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
            .if eax != INVALID_HANDLE_VALUE
                mov     hFile, eax
                mov     editstream.dwCookie, eax
                mov     editstream.pfnCallback, offset xStreamOut
                invoke  SendMessage, hEdit, EM_STREAMOUT, SF_RTF, addr editstream
                invoke  CloseHandle, hFile
                mov     szInitDir, 0
                invoke  lstrcat, addr szInitDir, ofn.lpstrFile
                invoke  PathRemoveFileSpec, addr szInitDir
            .endif
        .endif
    ret
xSaveas endp

xStreamOut proc      dwCookie:DWORD, pBuffer:DWORD, NumBytes:DWORD, pBytesWritten:DWORD
    invoke  WriteFile, hFile, pBuffer, NumBytes, pBytesWritten, 0
    xor eax,1
    ret
xStreamOut endp

xPrint proc uses edi
local xPerInch:DWORD
local yPerInch:DWORD
local TextSize:DWORD
local pd:PRINTDLG
local doc:DOCINFO
local cr:CHARRANGE
local fr:FORMATRANGE
local rect:RECT
    invoke  RtlZeroMemory, addr pd, sizeof pd
    invoke  RtlZeroMemory, addr doc, sizeof doc
    mov     pd.lStructSize, sizeof pd
    m2m     pd.hwndOwner, hwnd
    m2m     pd.hInstance, hInstance
    mov     pd.Flags, PD_RETURNDC or PD_ALLPAGES or PD_COLLATE
    mov     pd.nFromPage, 1
    mov     pd.nToPage, 1
    mov     pd.nMaxPage, -1
    mov     pd.nCopies, 1
    invoke  PrintDlg, addr pd
    .if !eax
        ret
    .endif
    mov     doc.cbSize, sizeof doc
    mov     doc.lpszDocName, offset AppName
    m2m     fr.hdc, pd.hDC
    m2m     fr.hdcTarget, pd.hDC
    invoke  GetDeviceCaps, fr.hdc, LOGPIXELSX
    mov     xPerInch, eax
    invoke  GetDeviceCaps, fr.hdc, LOGPIXELSY
    mov     yPerInch, eax
    mov     eax, mL
    mov     rect.left, eax
    mov     eax, mT
    mov     rect.top, eax
    invoke  GetDeviceCaps, fr.hdc, HORZRES
    mov     ecx, 1440
    mul     ecx
    div     xPerInch
    mov     rect.right, eax
    mov     eax, mR
    sub     rect.right, eax
    invoke  GetDeviceCaps, fr.hdc, VERTRES
    mov     ecx, 1440
    mul     ecx
    div     yPerInch
    mov     rect.bottom, eax
    mov     eax, mB
    sub     rect.bottom, eax
    mov     ecx, 16
    lea     eax, fr.rcPage
    mov     edi, eax
    lea     eax, rect
    mov     esi, eax
    cld
    rep     movsb
    invoke  StartDoc, pd.hDC, addr doc
    invoke  SendMessage, hEdit, EM_EXGETSEL, 0, addr cr
    mov     eax, cr.cpMin
    mov     ebx, cr.cpMax
    .if ebx > eax && (pd.Flags & PD_SELECTION)
        mov     fr.chrg.cpMin, eax
        mov     fr.chrg.cpMax, ebx
        mov     TextSize, ebx
    .else
        invoke  SendMessage, hEdit, EM_HIDESELECTION, 1, 0
        mov     cr.cpMin, 0
        mov     cr.cpMax, -1
        invoke  SendMessage, hEdit, EM_EXSETSEL, 0, addr cr
        invoke  SendMessage, hEdit, EM_EXGETSEL, 0, addr cr
        m2m     fr.chrg.cpMin, cr.cpMin
        mov     fr.chrg.cpMax, -1
        push    cr.cpMax
        pop     TextSize
        mov     cr.cpMin, 0
        mov     cr.cpMax, 0
        invoke  SendMessage, hEdit, EM_EXSETSEL, 0, addr cr
        invoke  SendMessage, hEdit, EM_HIDESELECTION, 0, 0
    .endif
@@:
    invoke  StartPage, pd.hDC
    cmp     eax, 0
    jle     @2
    mov     ecx, 16
    lea     eax, rect
    mov     esi, eax
    lea     eax, fr.rc
    mov     edi, eax
    cld
    rep     movsb
    invoke  SendMessage, hEdit, EM_FORMATRANGE, TRUE, addr fr
    mov     fr.chrg.cpMin, eax
    invoke  EndPage, pd.hDC
    cmp     eax, 0
    jle     @2
    mov     eax, fr.chrg.cpMin
    cmp     eax, 0
    jle     @1
    .if eax < TextSize
        jmp     @B
    .endif
@1:
    invoke  SendMessage, hEdit, EM_FORMATRANGE, 0, 0
    invoke  EndDoc, pd.hDC
    invoke  DeleteDC, pd.hDC
    ret
@2:
    invoke  AbortDoc, fr.hdc
    ret
xPrint endp